/*
GLSLFiqi2DJ[}bvj
*/
#include <fstream>
#include <string>
#include <iostream>
#include <GL/glew.h>
#include <GL/glut.h>
using namespace std;

int WindowPositionX = 200;  //EBhEʒuXW
int WindowPositionY = 100;  //EBhEʒuYW
int WindowWidth  = 512;     //EBhE̕
int WindowHeight = 512;     //EBhE̍
char WindowTitle[] = "E̎n܂";	//EBhẼ^Cg

//----------------------------------------------------
// VF[_RpC֘A
//----------------------------------------------------
GLuint shaderProgram;       //VF[_vO
/* _obt@IuWFNgID */
#define VERTEX  1
#define FRAGMENT  2

GLuint getShader(const char *file, int type)
{
	GLuint shader;
  if(type == VERTEX)        shader = glCreateShader(GL_VERTEX_SHADER);
  else if(type == FRAGMENT) shader = glCreateShader(GL_FRAGMENT_SHADER);

	ifstream ifs(file);
	istreambuf_iterator<char> vdataBegin(ifs);
	istreambuf_iterator<char> vdataEnd;
	string filedata(vdataBegin,vdataEnd);
	const char *vfile = filedata.c_str();

	glShaderSource(shader, 1, &vfile, NULL);	//\[XR[hVF[_IuWFNgɕϊ
	glCompileShader(shader);                  //RpC

	return shader;
}

void initShaders()
{
  //glew̏
  GLenum err = glewInit();
  if (err != GLEW_OK)
  {
	  printf("Error: %s\n", glewGetErrorString(err));
  }
	//VF[_[̓ǂݍ݂ƃRpC
  GLuint vertexShader   = getShader("test.vert", VERTEX);
  GLuint fragmentShader = getShader("test.frag", FRAGMENT);

  shaderProgram = glCreateProgram();  // vOIuWFNg̍쐬 

  glAttachShader(shaderProgram, vertexShader);
  glAttachShader(shaderProgram, fragmentShader);

  glLinkProgram(shaderProgram);
}

//////////////////////////
//iq̃TCY
int tate = 100, yoko = 100;
int vertexNumber = yoko * tate ;
int indexNumber  = 2 * (yoko-1) * (tate-1);

GLuint vertexPositionID, vertexColorID, vertexIndexID;
void initBuffers(){
	//iq̃obt@
	GLfloat (*vertices)[3] = new GLfloat[vertexNumber][3];
	GLfloat (*colors)[4]   = new GLfloat[vertexNumber][4];
	GLuint  (*indices)[3]  = new GLuint[indexNumber][3];
	int k=0; 
	for (int i = 0; i < tate; i++) {
		for (int j = 0; j < yoko; j++) {
			//_z̐ݒ
			vertices[k][0] = i;
			vertices[k][1] = j;
			vertices[k][2] = 0.0;

			GLfloat x = GLfloat(i - tate / 2) / tate;
			GLfloat y = GLfloat(j - yoko / 2) / yoko;
			GLfloat f = exp(-10.0*(x * x + y * y));//KEXz
			//J[z̐ݒ
			colors[k][0] = f;
			colors[k][1] = f;
			colors[k][2] = f;
			colors[k][3] = 1.0;
			k++;
		}
	}

	k=0;
	for (int i = 0; i < tate - 1; i++) {
		for (int j = 0; j < yoko - 1; j++) {
			indices[k][0] =yoko * i + j;             //Op`P̒_P
			indices[k][1] =yoko * i + (j + 1);       //Op`P̒_Q
			indices[k][2] =yoko * (i + 1) + (j + 1); //Op`P̒_R
			k++;
			indices[k][0] =yoko * i + j;             //Op`Q̒_P
			indices[k][1] =yoko * (i + 1) + j;       //Op`Q̒_Q
			indices[k][2] =yoko * (i + 1) + (j + 1); //Op`Q̒_R
			k++;
		}
	}

  glGenBuffers(1, &vertexPositionID); 
	glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
  glBufferData(GL_ARRAY_BUFFER, 3*vertexNumber * sizeof(GLfloat), vertices , GL_STATIC_DRAW);

  glGenBuffers(1, &vertexColorID); 
	glBindBuffer(GL_ARRAY_BUFFER, vertexColorID);
  glBufferData(GL_ARRAY_BUFFER, 4*vertexNumber * sizeof(GLfloat), colors , GL_STATIC_DRAW);

	glGenBuffers(1, &vertexIndexID);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, 3*indexNumber*sizeof(GLuint), indices, GL_STATIC_DRAW);

	delete [] vertices;
	delete [] colors;
	delete [] indices;
}

//----------------------------------------------------
// ݒ̊֐
//----------------------------------------------------
void initialize(void){
	glClearColor(0.0, 0.0, 0.0, 1.0); //wiF
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glViewport( 0, 0, WindowWidth, WindowHeight );
	gluPerspective(30.0, (double)WindowWidth/(double)WindowHeight, 0.1, 1000.0); //e@̎̐gluPerspactive(th, w/h, near, far);

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	gluLookAt(
		   0.0,  0.0, 186.0,  // _̈ʒux,y,z;
		   0.0,  0.0, 0.0,    // E̒Sʒu̎QƓ_Wx,y,z
		   0.0,  1.0, 0.0);   // Ȅ̃xNgx,y,z
}
//--------------------------------------------------------
// AChɌĂяo֐
//--------------------------------------------------------
void idle(){
 glutPostRedisplay(); //glutDisplayFunc()Ps
}
//----------------------------------------------------
// `֐
//----------------------------------------------------
void draw(){	

	glPushMatrix();
		glTranslatef(-yoko/2+0.5, -tate/2+0.5, 0.0);     //sړ
		glRotatef(0.0 , 0.0, 0.0, 1.0);  //]

		glEnableClientState(GL_VERTEX_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
		glVertexPointer(3, GL_FLOAT, 0, 0);

		glEnableClientState(GL_COLOR_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexColorID);
		glColorPointer(4, GL_FLOAT, 0, 0);

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
		glDrawElements(GL_TRIANGLES, 3*indexNumber,	GL_UNSIGNED_INT, 0);
	glPopMatrix();
}

void display(void){
	glClear(GL_COLOR_BUFFER_BIT); //obt@̏

  glUseProgram(shaderProgram);

	draw();

	glUseProgram(0);

	glutSwapBuffers(); //glutInitDisplayMode(GLUT_DOUBLE)Ń_uobt@O𗘗p
}

//----------------------------------------------------
// C֐
//----------------------------------------------------
int main(int argc, char** argv){
	glutInit(&argc, argv);                                     //̏
	glutInitWindowPosition(WindowPositionX, WindowPositionY);  //EBhËʒu̎w
	glutInitWindowSize(WindowWidth, WindowHeight);             //EBhETCY̎w
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);              //fBXvC[h̎w
	glutCreateWindow(WindowTitle);                             //EBhE̍쐬
	glutDisplayFunc(display);                                  //`掞ɌĂяo֐w肷i֐Fdisplayj
	glutIdleFunc(idle);                                        //vOAChԎɌĂяo֐
  initShaders();
	initBuffers();
	initialize();                                              //ݒ̊֐Ăяo
	glutMainLoop();
 	glDeleteProgram(shaderProgram);
	return 0;
}
